SystemOrganization addCategory: #'Spec-Presenter'!

!Object methodsFor: '*Spec-Presenter' stamp: 'BenjaminVanRyseghem 6/5/2012 00:28'!
isSpecPresenter

	^ false! !

Object subclass: #SpecPresenter
	instanceVariableNames: 'type commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Presenter'!

!SpecPresenter commentStamp: '<historical>' prior: 0!
A SpecPresenter is a object used to describe a user interface!

!SpecPresenter class methodsFor: 'instance creation' stamp: 'johanfabry 6/4/2012 21:35'!
abstract
	^self new type: #AbstractSpec.! !

!SpecPresenter class methodsFor: 'instance creation' stamp: 'johanfabry 6/4/2012 21:36'!
button
	^self new type: #ButtonSpec.! !

!SpecPresenter class methodsFor: 'instance creation' stamp: 'johanfabry 6/4/2012 21:36'!
checkbox
	^self new type: #CheckboxSpec.! !

!SpecPresenter class methodsFor: 'instance creation' stamp: 'johanfabry 6/4/2012 21:36'!
composed
	^self new type: #ComposableSpec.! !

!SpecPresenter class methodsFor: 'instance creation' stamp: 'johanfabry 6/4/2012 21:36'!
droplist
	^self new type: #DropListSpec.! !

!SpecPresenter class methodsFor: 'instance creation' stamp: 'johanfabry 6/4/2012 21:36'!
iconlist
	^self new type: #IconListSpec.! !

!SpecPresenter class methodsFor: 'instance creation' stamp: 'johanfabry 6/4/2012 21:36'!
label
	^self new type: #LabelSpec.! !

!SpecPresenter class methodsFor: 'instance creation' stamp: 'johanfabry 6/4/2012 21:36'!
multicolumnlist
	^self new type: #MultiColumnListSpec.! !

!SpecPresenter class methodsFor: 'instance creation' stamp: 'johanfabry 6/4/2012 21:37'!
raw
	^self new type: #RawSpec.! !

!SpecPresenter class methodsFor: 'instance creation' stamp: 'johanfabry 6/4/2012 21:37'!
textfield 
	^self new type: #TextFieldSpec.! !

!SpecPresenter class methodsFor: 'instance creation' stamp: 'johanfabry 6/4/2012 21:37'!
tree
	^self new type: #TreeSpec.! !

!SpecPresenter methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/5/2012 00:00'!
add: aSpec 
	
	self add: aSpec origin: 0@0 corner: 1@1! !

!SpecPresenter methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/5/2012 00:00'!
add: aSpec origin: originPoint corner: cornerPoint 

	self add: aSpec origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecPresenter methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/5/2012 00:37'!
add: aSpec origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint
	| spec layout |
	
	layout := {#FrameLayout. #fractions:offsets:. originPoint corner: cornerPoint . ooPoint corner: ocPoint}.
	spec := aSpec isSymbol
		ifTrue: [{#model. aSpec}]
		ifFalse: [aSpec].

	self privateAdd: {spec .#layout:. layout}! !

!SpecPresenter methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/5/2012 00:03'!
add: modelGetter withSpec: aSymbol 
	
	self add: modelGetter withSpec: aSymbol origin: 0@0 corner: 1@1! !

!SpecPresenter methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/5/2012 00:03'!
add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint 

	self add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecPresenter methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/5/2012 00:02'!
add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint
	| spec layout |
	
	layout := {#FrameLayout. #fractions:offsets:. originPoint corner: cornerPoint . ooPoint corner: ocPoint}.
	spec := {#model. modelGetter . aSymbol }.

	self privateAdd: {spec. #layout:. layout}! !

!SpecPresenter methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 6/4/2012 23:47'!
asArray
	| result |
	
	result := Array new: (self commands size + 1).
	result at: 1 put: self type.
	
	self commands doWithIndex: [:e :i | result at: i+1 put: e ].
	^result
	! !

!SpecPresenter methodsFor: 'accessing' stamp: 'johanfabry 6/4/2012 21:39'!
commands
	^ commands! !

!SpecPresenter methodsFor: 'accessing' stamp: 'johanfabry 6/4/2012 21:39'!
commands: anObject
	commands := anObject! !

!SpecPresenter methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 6/4/2012 23:46'!
initialize 
	super initialize.
	
	type := #ComposableSpec.
	self commands: OrderedCollection new.! !

!SpecPresenter methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/5/2012 09:53'!
isSpecPresenter

	^ true! !

!SpecPresenter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/5/2012 09:46'!
privateAdd: anArray

	self send: #add: withArguments: { anArray }
	"self commands add: #add:.
	self commands add: anArray"! !

!SpecPresenter methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/5/2012 09:45'!
send: aSelector withArguments: arguments

	self commands add: aSelector.
	arguments do: [:e | self commands add: e ]! !

!SpecPresenter methodsFor: 'accessing' stamp: 'johanfabry 6/4/2012 21:23'!
type
	^ type! !

!SpecPresenter methodsFor: 'accessing' stamp: 'johanfabry 6/4/2012 21:23'!
type: anObject
	type := anObject! !
